/*
 * UserText.c
 *
 * Created: 27.12.2012 09:27:47
 *  Author: Nuckey
 */ 

#include "Main.Text.h"




#include <util/delay.h>
#include <avr/sleep.h>
#include <stdlib.h>
#include <string.h>
#include <avr/eeprom.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <math.h>

#include "Lcd.h"

// with integer factors the ADC-value will be changed to mV resolution in ReadADC !
// all if statements are corrected to the mV resolution.
//###################################################################################
//#				Strings in PROGMEM or in EEprom										#
//###################################################################################

#if (UI_LANGUAGE == LANG_GERMAN)
const unsigned char TestRunning[] MEM_TEXT = "Testen...";	//";
const unsigned char BatWeak[] MEM_TEXT = "schwach";
const unsigned char BatEmpty[] MEM_TEXT = "leer!";			//";
const unsigned char TestFailed2[] MEM_TEXT = "defektes ";	//";
const unsigned char Bauteil[] MEM_TEXT = "Bauteil";			//";
const unsigned char Diode[] MEM_TEXT = "Diode: ";
const unsigned char GAK[] MEM_TEXT = "GAK=";
const unsigned char Triac[] MEM_TEXT = "Triac";
const unsigned char Thyristor[] MEM_TEXT = "Thyristor";
const unsigned char Unknown[] MEM_TEXT = " unbek.";			//";
const unsigned char TestFailed1[] MEM_TEXT = "Kein,unbek. oder";
const unsigned char OrBroken[] MEM_TEXT = "oder defekt ";	//";
const unsigned char TestTimedOut[] MEM_TEXT = "Timeout!";
#ifdef WITH_SELFTEST
const unsigned char SELFTEST[] MEM2_TEXT = "Selbsttest ..";
const unsigned char RELPROBE[] MEM2_TEXT = "isolate Probe!";
const unsigned char ATE[] MEM_TEXT = "Test Ende";
#endif
#endif

#if( UI_LANGUAGE == LANG_ENGLISH )
const unsigned char TestRunning[] MEM_TEXT = "Testing...";	//";
const unsigned char BatWeak[] MEM_TEXT = "weak";			//";
const unsigned char BatEmpty[] MEM_TEXT = "empty!";			//";
const unsigned char TestFailed2[] MEM_TEXT = "damaged ";	//";
const unsigned char Bauteil[] MEM_TEXT = "part";			//";
const unsigned char Diode[] MEM_TEXT = "Diode: ";
const unsigned char GAK[] MEM_TEXT = "GAC=";
const unsigned char Triac[] MEM_TEXT = "Triac";
const unsigned char Thyristor[] MEM_TEXT = "Thyristor";
const unsigned char Unknown[] MEM_TEXT = " unknown";			//";
const unsigned char TestFailed1[] MEM_TEXT = "No, unknown, or"; //";
const unsigned char OrBroken[] MEM_TEXT = "or damaged ";		//";
const unsigned char TestTimedOut[] MEM_TEXT = "Timeout!";
#ifdef WITH_SELFTEST
const unsigned char SELFTEST[] MEM2_TEXT = "Selftest mode..";
const unsigned char RELPROBE[] MEM2_TEXT = "isolate Probe!";
const unsigned char ATE[] MEM_TEXT = "Test End";
#endif
#endif

#if (UI_LANGUAGE == LANG_POLISH)		//polnisch
const unsigned char TestRunning[] MEM_TEXT = "Testowanie..."; //";
const unsigned char BatWeak[] MEM_TEXT = "slaba"; //";
const unsigned char BatEmpty[] MEM_TEXT = "za slaba";
const unsigned char TestFailed2[] MEM_TEXT = "lub uszkodz.";
const unsigned char Bauteil[] MEM_TEXT = "Elemen"; //t";
const unsigned char Diode[] MEM_TEXT = "Dioda: ";
const unsigned char GAK[] MEM_TEXT = "GAK=";
const unsigned char Triac[] MEM_TEXT = "Triak";
const unsigned char Thyristor[] MEM_TEXT = "Tyrystor"; //";
const unsigned char Unknown[] MEM_TEXT = " nieznany";
const unsigned char TestFailed1[] MEM_TEXT = "brak elementu"; //";
const unsigned char OrBroken[] MEM_TEXT = "lub uszkodz. ";
const unsigned char TestTimedOut[] MEM_TEXT = "Timeout!";
#ifdef WITH_SELFTEST
const unsigned char SELFTEST[] MEM2_TEXT = "Selftest mode..";
const unsigned char RELPROBE[] MEM2_TEXT = "isolate Probe!";
const unsigned char ATE[] MEM_TEXT = "Test End";
#endif
#endif

#if (UI_LANGUAGE == LANG_CZECH)		//Tschechisch
const unsigned char TestRunning[] MEM_TEXT = "Probiha mereni..";
const unsigned char BatWeak[] MEM_TEXT = "slaba"; //";
const unsigned char BatEmpty[] MEM_TEXT = "prazdna!";
const unsigned char TestFailed2[] MEM_TEXT = "vadna "; //";
const unsigned char Bauteil[] MEM_TEXT = "soucastka"; //";
const unsigned char Diode[] MEM_TEXT = "Dioda: ";
const unsigned char GAK[] MEM_TEXT = "GAK=";
const unsigned char Triac[] MEM_TEXT = "Triak";
const unsigned char Thyristor[] MEM_TEXT = "Tyristor"; //";
const unsigned char Unknown[] MEM_TEXT = " neznama"; //";
const unsigned char TestFailed1[] MEM_TEXT = "Zadna, neznama"; //";
const unsigned char OrBroken[] MEM_TEXT = "nebo vadna "; //";
const unsigned char TestTimedOut[] MEM_TEXT = "Timeout!";
#ifdef WITH_SELFTEST
const unsigned char SELFTEST[] MEM2_TEXT = "Selftest mode..";
const unsigned char RELPROBE[] MEM2_TEXT = "isolate Probe!";
const unsigned char ATE[] MEM_TEXT = "Test End";
#endif
#endif

#if (UI_LANGUAGE == LANG_SLOVAK)		//slowakisch
const unsigned char TestRunning[] MEM_TEXT = "PREBIEHA TEST"; //";
const unsigned char BatWeak[] MEM_TEXT = "slaba"; //";
const unsigned char BatEmpty[] MEM_TEXT = "prazdna!";
const unsigned char TestFailed2[] MEM_TEXT = "vadna "; //";
const unsigned char Bauteil[] MEM_TEXT = "suciastka!";
const unsigned char Diode[] MEM_TEXT = "Dioda: ";
const unsigned char GAK[] MEM_TEXT = "GAK=";
const unsigned char Triac[] MEM_TEXT = "Triak";
const unsigned char Thyristor[] MEM_TEXT = "Tyristor"; //";
const unsigned char Unknown[] MEM_TEXT = " neznama"; //";
const unsigned char TestFailed1[] MEM_TEXT = "Ziadna, neznama"; //";
const unsigned char OrBroken[] MEM_TEXT = "alebo vadna "; //";
const unsigned char TestTimedOut[] MEM_TEXT = "Timeout!";
#ifdef WITH_SELFTEST
const unsigned char SELFTEST[] MEM2_TEXT = "Selftest mode..";
const unsigned char RELPROBE[] MEM2_TEXT = "isolate Probe!";
const unsigned char ATE[] MEM_TEXT = "Test End";
#endif
#endif

#if (UI_LANGUAGE == LANG_SLOVENE)                    //slovenian
const unsigned char TestRunning[] MEM_TEXT = "Testiranje...";
const unsigned char BatWeak[] MEM_TEXT = "slaba!";
const unsigned char BatEmpty[] MEM_TEXT = "prazna!";
const unsigned char TestFailed2[] MEM_TEXT = "pokvarjen ";
const unsigned char Bauteil[] MEM_TEXT = "del";
const unsigned char Diode[] MEM_TEXT = "Dioda: ";
const unsigned char GAK[] MEM_TEXT = "GAC=";
const unsigned char Triac[] MEM_TEXT = "Triak";
const unsigned char Thyristor[] MEM_TEXT = "Tiristor";
const unsigned char Unknown[] MEM_TEXT = " neznan";
const unsigned char TestFailed1[] MEM_TEXT = "Ni, neznan, ali";
const unsigned char OrBroken[] MEM_TEXT = "ali zanic ";
const unsigned char TestTimedOut[] MEM_TEXT = "Timeout!";
#ifdef WITH_SELFTEST
const unsigned char SELFTEST[] MEM2_TEXT = "Selftest mode..";
const unsigned char RELPROBE[] MEM2_TEXT = "isolate Probe!";
const unsigned char ATE[] MEM_TEXT = "Test End";
#endif
#endif

#if (UI_LANGUAGE == LANG_DUTCH)                      //dutch
const unsigned char TestRunning[] MEM_TEXT = "Testen...";
const unsigned char BatWeak[] MEM_TEXT = "laag";
const unsigned char BatEmpty[] MEM_TEXT = "leeg!";
const unsigned char TestFailed2[] MEM_TEXT = "defect ";
const unsigned char Bauteil[] MEM_TEXT = "component";
const unsigned char Diode[] MEM_TEXT = "Diode: ";
const unsigned char GAK[] MEM_TEXT = "GAC=";
const unsigned char Triac[] MEM_TEXT = "Triac";
const unsigned char Thyristor[] MEM_TEXT = "Thyristor";
const unsigned char Unknown[] MEM_TEXT = " onbekend";
const unsigned char TestFailed1[] MEM_TEXT = "Geen, onbekend,";
const unsigned char OrBroken[] MEM_TEXT = "of defect ";
const unsigned char TestTimedOut[] MEM_TEXT = "Timeout!";
#ifdef WITH_SELFTEST
const unsigned char SELFTEST[] MEM2_TEXT = "Zelftest mode..";
const unsigned char RELPROBE[] MEM2_TEXT = "isolate Probe";
const unsigned char ATE[] MEM_TEXT = "Test Einde";
#endif
#endif

#if (UI_LANGUAGE == LANG_RUSSIAN)                    //Russian
   const unsigned char TestRunning[] MEM_TEXT = {'T','e','c',Cyr_t,Cyr_i,'p','o',Cyr_v,'a',Cyr_n,Cyr_i,'e','.','.','.',0}; 
   const unsigned char BatWeak[] MEM_TEXT = {'c',Cyr_l,'a',Cyr_b,Cyr_y,Cyr_j,0}; 
   const unsigned char BatEmpty[] MEM_TEXT = {Cyr_p,Cyr_U,'c',Cyr_t,'o',Cyr_j,'!',0};
   const unsigned char TestFailed2[] MEM_TEXT = {Cyr_p,'o',Cyr_v,'p','e',Cyr_zsch,Cyr_d,'e',Cyr_n,' ',0};
   const unsigned char Bauteil[] MEM_TEXT = {Cyr_tsch,'a','c',Cyr_t,Cyr_hh,0}; 
   const unsigned char Diode[] MEM_TEXT = {Cyr_D,Cyr_i,'o',Cyr_d,':',0};
   const unsigned char GAK[] MEM_TEXT = "GAC=";
   const unsigned char Triac[] MEM_TEXT = {'C',Cyr_i,Cyr_m,Cyr_i,'c',Cyr_t,'o','p',0};
   const unsigned char Thyristor[] MEM_TEXT = {Cyr_t,Cyr_i,'p',Cyr_i,'c',Cyr_t,'o','p',0};
   const unsigned char Unknown[] MEM_TEXT = {' ',Cyr_n,'e',Cyr_i,Cyr_z,Cyr_v,'e','c',Cyr_t,Cyr_n,Cyr_y,Cyr_j,0}; 
   const unsigned char TestFailed1[] MEM_TEXT = {'o',Cyr_t,'c',Cyr_U,Cyr_t,'c',Cyr_t,Cyr_v,Cyr_U,'e',Cyr_t,0};
   const unsigned char OrBroken[] MEM_TEXT = {Cyr_i,Cyr_l,Cyr_i,' ',Cyr_p,'o',Cyr_v,'p','e',Cyr_zsch,Cyr_d,'e',Cyr_n,0};
   const unsigned char TestTimedOut[] MEM_TEXT = {Cyr_v,'p','e',Cyr_m,Cyr_ja,' ',Cyr_t,'e','c',Cyr_t,Cyr_i,'p','o',Cyr_v,'a',Cyr_n,Cyr_i,Cyr_ja,Cyr_v,Cyr_y,Cyr_sch,Cyr_l,'o','!',0};

 #ifdef WITH_SELFTEST
   const unsigned char SELFTEST[] MEM2_TEXT = "Selftest mode..";
   const unsigned char RELPROBE[] MEM2_TEXT = {'o',Cyr_t,Cyr_k,Cyr_l,Cyr_ju,Cyr_tsch,Cyr_i,Cyr_t,'b',' ',Cyr_z,'o',Cyr_n,Cyr_d,0};
   const unsigned char ATE[] MEM_TEXT = {Cyr_k,'o',Cyr_n,'e',Cyr_c,' ','c','a',Cyr_m,'o',Cyr_t,'e','c',Cyr_t,Cyr_i,'p','o',Cyr_v,'a',Cyr_n,Cyr_i,Cyr_ja,0};
 #endif
 
#endif



const unsigned char Bat_str[] MEM_TEXT = "Bat. ";
const unsigned char OK_str[] MEM_TEXT = "OK";
const unsigned char mosfet_str[] MEM_TEXT = "-MOS";
const unsigned char jfet_str[] MEM_TEXT = "JFET";
const unsigned char GateCap_str[] MEM_TEXT = "C=";
const unsigned char hfe_str[] MEM_TEXT ="B=";
const unsigned char NPN_str[] MEM_TEXT = "NPN ";
const unsigned char PNP_str[] MEM_TEXT = "PNP ";

#ifdef EBC_STYLE
const unsigned char EBC_str[] MEM_TEXT = " EBC=";
const unsigned char GDS_str[] MEM_TEXT = " GDS=";
#else
const unsigned char N123_str[] MEM_TEXT = " 123=";
#endif

const unsigned char Uf_str[] MEM_TEXT = "Uf=";
const unsigned char vt_str[] MEM_TEXT = " Vt=";
const unsigned char Vgs_str[] MEM_TEXT = "@Vgs=";
const unsigned char CapZeich[] MEM_TEXT = {'-',LCD_CHAR_CAP,'-',0};
const unsigned char Cell_str[] MEM_TEXT = "Cell!";
const unsigned char VCC_str[] MEM_TEXT = "VCC=";
 
#if FLASHEND > 0x1fff
const unsigned char ESR_str[] MEM_TEXT = " ESR=";
const unsigned char Lis_str[] MEM_TEXT = "L=";
#endif


const unsigned char AnKat[] MEM_TEXT = {'-', LCD_CHAR_DIODE1, '-',0};
const unsigned char KatAn[] MEM_TEXT = {'-', LCD_CHAR_DIODE2, '-',0};
const unsigned char Dioden[] MEM_TEXT = {'*',LCD_CHAR_DIODE1, ' ', ' ',0};
const unsigned char Resistor_str[] MEM_TEXT = {'-', LCD_CHAR_RESIS1, LCD_CHAR_RESIS2,'-',0};
const unsigned char VERSION_str[] MEM_TEXT = "Version 1.04k";

#ifdef WITH_SELFTEST
const unsigned char URefT[] MEM2_TEXT = "Ref=";
const unsigned char RHfakt[] MEM2_TEXT = "RHf=";
const unsigned char RH1L[] MEM2_TEXT = "RH-";
const unsigned char RH1H[] MEM2_TEXT = "RH+";
const unsigned char RLRL[] MEM2_TEXT = "+RL- 12 13 23";
const unsigned char RHRH[] MEM2_TEXT = "+RH- 12 13 23";
#define LCD_CLEAR
#endif

#ifdef CHECK_CALL
const unsigned char RIHI[] MEM_TEXT = "Ri_Hi=";
const unsigned char RILO[] MEM_TEXT = "Ri_Lo=";
const unsigned char C0_str[] MEM_TEXT = "C0 ";
const unsigned char T50HZ[] MEM2_TEXT = " 50Hz";
#endif

#ifdef AUTO_CAL
const unsigned char MinCap_str[] MEM_TEXT = " >100nF";
const unsigned char REF_C_str[] MEM_TEXT = "REF_C=";
const unsigned char REF_R_str[] MEM_TEXT = "REF_R=";
#endif


const unsigned char DiodeIcon1[] MEM_TEXT = { 0x11,0x19,0x1d,0x1f,0x1d,0x19,0x11,0x00};	// Diode-Icon Anode left
const unsigned char DiodeIcon2[] MEM_TEXT = { 0x11,0x13,0x17,0x1f,0x17,0x13,0x11,0x00};	// Diode-Icon Anode right	 
const unsigned char CapIcon[] MEM_TEXT = { 0x1b,0x1b,0x1b,0x1b,0x1b,0x1b,0x1b,0x00};	// Capacitor Icon				 
const unsigned char ResIcon1[] MEM_TEXT = { 0x00,0x0f,0x08,0x18,0x08,0x0f,0x00,0x00};	// Resistor Icon1			 
const unsigned char ResIcon2[] MEM_TEXT = { 0x00,0x1e,0x02,0x03,0x02,0x1e,0x00,0x00};	// Resistor Icon2



#ifdef LCD_CYRILLIC	//generate Omega- and -character as Custom-character, because these characters are not inclluded with the cyrillic character set
   const unsigned char CyrillicOmegaIcon[] MEM_TEXT = {0,0,14,17,17,10,27,0};	//Omega
   const unsigned char CyrillicMuIcon[] MEM_TEXT = {0,17,17,17,19,29,16,16};	//
#endif

const uint8_t PrefixTab[] MEM_TEXT = { 'p','n',LCD_CHAR_U,'m',0,'k','M'}; // p,n,u,m,-,k,M